<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Procedure Symbols</TITLE>
<link href="suif1_54.html" rel=Next>
<link href="suif1_52.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_52.html">previous</A>, <A HREF="suif1_54.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC53" HREF="suif1_toc.html#TOC53">Procedure Symbols</A></H2>
<P>
<A NAME="IDX350"></A>
<A NAME="IDX351"></A>

</P>
<P>
<A NAME="IDX352"></A>
Procedure symbols are represented by objects of the <CODE>proc_sym</CODE>
class.  SUIF does not support nested procedures, so these symbols may
only be entered in global and file symbol tables.  The fields in a
procedure symbol hold information about the procedure, including a
pointer to the body if it is in memory.  The <CODE>proc_sym</CODE> class also
provides methods to read procedure bodies from input files, write them
to the output files, and flush them from memory.

</P>
<P>
<A NAME="IDX353"></A>
<A NAME="IDX354"></A>
<A NAME="IDX355"></A>
Each procedure symbol contains a field to record the source language for
the procedure.  The <CODE>src_lang</CODE> and <CODE>set_src_lang</CODE> methods
access this field, which holds a value from <CODE>src_lang_type</CODE>
enumeration: <CODE>src_unknown</CODE>, <CODE>src_c</CODE>, <CODE>src_fortran</CODE>, or
<CODE>src_verilog</CODE>.  Other values may be added in the future.

</P>
<P>
<A NAME="IDX356"></A>
<A NAME="IDX357"></A>
A procedure symbol also has a field that specifies the type of the
procedure.  The <CODE>type</CODE> and <CODE>set_type</CODE> methods retrieve and
change this field.  The type must be a function type.  See section <A HREF="suif1_64.html#SEC64">Function Types</A>.

</P>
<P>
<A NAME="IDX358"></A>
<A NAME="IDX359"></A>
<A NAME="IDX360"></A>
The body of a procedure is represented by its abstract syntax tree.
See section <A HREF="suif1_10.html#SEC10">Abstract Syntax Trees</A>.  The procedure symbol contains a pointer to the root node
of this tree.  The <CODE>block</CODE> and <CODE>set_block</CODE> methods access this
pointer.  If the body is not in memory, the <CODE>block</CODE> pointer will be
<CODE>NULL</CODE>; the <CODE>is_in_memory</CODE> method is provided to check this
condition.

</P>
<P>
<A NAME="IDX361"></A>
<A NAME="IDX362"></A>
<A NAME="IDX363"></A>
<A NAME="IDX364"></A>
The <CODE>proc_sym</CODE> class contains the methods to read procedure bodies
from binary SUIF files and to write them out again.  The details of SUIF
I/O are thus hidden from users; only entire procedures can be read and
written.  If one of the input files contains the body for a procedure, a
pointer to the file set entry (see section <A HREF="suif1_9.html#SEC9">File Set Entries</A>) is recorded in
the procedure symbol.  The <CODE>file</CODE> method retrieves this pointer for
a particular <CODE>proc_sym</CODE>.  The same procedure can be read in and
flushed from memory many times, but once it has been written out it can
no longer be read or written again.  The procedure symbol contains a
flag to indicate if it has been written out yet.  The <CODE>is_written</CODE>
method returns the value of this flag.  The <CODE>is_readable</CODE> method
checks if the procedure body exists in one of the input files and if it
has not yet been written out.  If this method returns <CODE>TRUE</CODE>, the
<CODE>read_proc</CODE> method can be used to read the body of the procedure.
By default, <CODE>read_proc</CODE> also converts the procedure to expression
tree form (see section <A HREF="suif1_31.html#SEC31">Expression Trees</A>) but it does not convert to Fortran
form (see section <A HREF="suif1_89.html#SEC89">Features for Compiling Fortran</A>).  The <CODE>exp_trees</CODE> and
<CODE>use_fortran_form</CODE> parameters to <CODE>read_proc</CODE> can be used to
override these defaults.

</P>
<P>
<A NAME="IDX365"></A>
After a procedure body has been read in and possibly modified, it can be
written to the output file using the procedure symbol's
<CODE>write_proc</CODE> method.  You must specify the file set entry to which
the procedure should be written.  In most cases, the input and output
file set entry will be the same, and you will just use the <CODE>file</CODE>
method to determine the output file set entry.  As mentioned above, once
a procedure has been written out it cannot be rewritten or read in
again.  Obviously, it should not be changed after that point because the
changes could not be saved.  Besides avoiding changes directly to the
procedure, however, you must also be careful to avoid certain changes to
the global symbol tables.  The symbols and types within the procedure
are written out using their ID numbers.  See section <A HREF="suif1_50.html#SEC50">Numbering Types and Symbols</A>.  Thus, you must not do anything to the global symbol tables
that would cause the ID numbers for those symbols and types to change.
For example, moving a symbol from a file symbol table to the global
symbol table would require that its ID number change.  The best solution
to this is to not write out the procedures until you are certain that
such changes to the symbol tables will not be needed.

</P>
<P>
<A NAME="IDX366"></A>
When a procedure body is no longer needed, typically after it has been
written out, call the <CODE>flush_proc</CODE> method for the procedure symbol
to deallocate the storage used by the procedure.  In some cases, you may
want to flush the procedure before it is written.  For example,
interprocedural analysis requires that all procedures be read in and
analyzed together.  To save space, the procedures can be summarized for
the purpose of the particular analysis and then flushed.  After the
analysis is complete, they can be re-read and the results can be
attached to the code.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_52.html">previous</A>, <A HREF="suif1_54.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
